	# ###########	Etile bringup					################################
# ###########	Author: Kurrinchi Balakrishnan	###########################
# ###########	Date: 7/3/2018					###############################

# versin 1p0 
# kurrinchi added the GUI


# versin 2p0 
# Removing the iVAL portion as those are only for the pre defined receipe
# Removing the cADP portion as those are only for the pre defined receipe
# adding diffrent PRBS
# adding enable and disable button for measurement
# adding enable and disable button for serdes reset



proc etile_write_reg	{ addr_in_hex reg_value_in_hex chan avmm } {
if {0} { puts [info level 0] }	
	global  XCVR_DEBUG_TOOL_KIT_BASE_ADDRESS
	global  status_tool_type_for_reg_read_write
	global 	BASE_ETILE_EHIPC3_100G_XCVR_LO
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L1
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L2
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L3
	global 	ip_sub_variant_option 

	if {$status_tool_type_for_reg_read_write == "native_phy_adme_enabled" } {
		set addr_in_hex [ string tolower $addr_in_hex]
		set reg_value_in_hex [ string tolower $reg_value_in_hex]
		#set usb [string toupper $usb]
	
		set slave_path $avmm 	
		set slave_path [claim_service slave $slave_path foo]
		set word_addr_reg [expr $addr_in_hex + $XCVR_DEBUG_TOOL_KIT_BASE_ADDRESS * $chan]	
		set byte_addr_reg [expr $word_addr_reg << 2]
		#puts "master_write_32 $slave_path [format "0x%x" $byte_addr_reg]  0x[format "%08s" [dec2hex [expr $reg_value_in_hex]]]\n"
		master_write_32 $slave_path [format "0x%x" $byte_addr_reg]  0x[format "%08s" [format %X [expr $reg_value_in_hex]]]
		close_service slave $slave_path
	} else {
		if {[string first nrz $ip_sub_variant_option] > -1 } {
		
			if { $chan == 0 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_LO $addr_in_hex $reg_value_in_hex }
			if { $chan == 1 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_L1 $addr_in_hex $reg_value_in_hex }
			if { $chan == 2 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_L2 $addr_in_hex $reg_value_in_hex }
			if { $chan == 3 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_L3 $addr_in_hex $reg_value_in_hex }
		} else {
		
			if { $chan == 0 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_LO $addr_in_hex $reg_value_in_hex }
			if { $chan == 1 } { reg_write $BASE_ETILE_EHIPC3_100G_XCVR_L2 $addr_in_hex $reg_value_in_hex }
		}
	}
}
proc etile_read_reg		{ addr_in_hex chan avmm {no_of_reg 1} {start 8} {stop 9}} {
	global XCVR_DEBUG_TOOL_KIT_BASE_ADDRESS
	global status_tool_type_for_reg_read_write
	global 	BASE_ETILE_EHIPC3_100G_XCVR_LO
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L1
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L2
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L3
	global 	ip_sub_variant_option 
		
	if {$status_tool_type_for_reg_read_write == "native_phy_adme_enabled" } {
		set addr_in_hex [ string tolower $addr_in_hex]
		# puts "\n\navmm = $avmm\n\n\n" 
		set slave_path $avmm 	
		set slave_path [claim_service slave $slave_path foo]
		# puts $addr_in_hex
		set word_addr_reg [expr $addr_in_hex + $XCVR_DEBUG_TOOL_KIT_BASE_ADDRESS * $chan]	
		# puts "word_addr_reg $word_addr_reg"
		set byte_addr_reg [expr $word_addr_reg << 2]
		# puts "byte_addr_reg $byte_addr_reg"
		set byte_addr_reg [format "0x%x" $byte_addr_reg]   
		# puts "byte_addr_reg $byte_addr_reg"
		set dprio_value [master_read_32 $slave_path $byte_addr_reg $no_of_reg]
		set dprio_value_mod ""
		foreach value $dprio_value {
			set val 0x[string range $value $start $stop]
			lappend dprio_value_mod $val
		}
		#puts $dprio_value_mod
		close_service slave $slave_path
		# puts "addr_in_hex=$addr_in_hex, dprio_value=$dprio_value"
		return $dprio_value_mod
	} else {
			if {[string first nrz $ip_sub_variant_option] > -1 } {
				
				if { $chan == 0 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_LO $addr_in_hex ] }
				if { $chan == 1 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_L1 $addr_in_hex ] }
				if { $chan == 2 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_L2 $addr_in_hex ] }
				if { $chan == 3 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_L3 $addr_in_hex ] }
			} else {
				
				if { $chan == 0 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_LO $addr_in_hex ] }
				if { $chan == 1 } { set read_val [ reg_read $BASE_ETILE_EHIPC3_100G_XCVR_L2 $addr_in_hex ] }
			}
		return $read_val
	}
}
proc etile_rdmwrite 	{ address bitmask newval chan avmm } {
	if {0} { puts [info level 0] }	
    set value [etile_read_reg $address $chan "$avmm"]
    set value [expr $value & [expr 0xFF & ~$bitmask]]
    set value [expr $value | $newval]
	etile_write_reg $address 0x[format %X $value] $chan "$avmm"
}
proc etile_pma_atribute 	{pma_attribute_code pma_attribute_data chan avmm  } {
	if {0}  { puts [lrange [info level [info level]] 0 3] }
	etile_write_reg 0x84 [expr $pma_attribute_data & 0xff] $chan $avmm  
	etile_write_reg 0x85 [expr $pma_attribute_data>>8 & 0xff] $chan $avmm  
	etile_write_reg 0x86 [expr $pma_attribute_code & 0xff] $chan $avmm  
	etile_write_reg 0x87 [expr $pma_attribute_code>>8 & 0xff] $chan $avmm  
	#etile_write_reg 0x90 0x1 $chan $avmm  
	etile_rdmwrite 0x90 0x1 0x1 $chan $avmm  
	set ret_val [etile_read_reg 0x88 $chan $avmm]
	etile_rdmwrite 0x8A 0xFF 0x80 $chan $avmm  
	return $ret_val
}

# ################################
# PMA attributes for Transceiver tab
# ################################
proc td_vod_rd { chan avmm} 		   	{ return [etile_pma_atribute 0x15 0x4100  $chan $avmm] }
proc td_post_tap1 { chan avmm} 		   	{ return [etile_pma_atribute 0x15 0x8100  $chan $avmm] }
proc td_pre_tap1 { chan avmm} 		   	{ return [etile_pma_atribute 0x15 0x0100  $chan $avmm] }
proc td_pre_tap2 { chan avmm} 		   	{ return [etile_pma_atribute 0x15 0xc100  $chan $avmm] }
proc td_pre_tap3 { chan avmm} 		   	{ return [etile_pma_atribute 0x15 0x3100  $chan $avmm] }
proc td_read_cdrlocked_reg 	{chan avmm } { set rx_is_lockedtodata1 1 ;	for { set i 0 } { $i < 100 } { incr i } { set rx_is_lockedtodata [expr [etile_read_reg 0x40080 $chan $avmm]]  ; if {$rx_is_lockedtodata == 0 } { set rx_is_lockedtodata1 0;break} } ;	return $rx_is_lockedtodata1 }
proc td_tx_ready 				{chan avmm } { set td_tx_ready1 1 ; for { set i 0 } { $i < 100 } { incr i } { set td_tx_ready [expr 0x01 & [etile_read_reg 0x40081 $chan $avmm]] ; if {$td_tx_ready == 0 } { set td_tx_ready1 0;break} } ; return $td_tx_ready1 }
proc td_rx_ready 				{chan avmm } { set td_rx_ready1 1 ; for { set i 0 } { $i < 100 } { incr i } { set td_rx_ready [expr 0x02 & [etile_read_reg 0x40081 $chan $avmm]] ; if {$td_rx_ready == 0 } { set td_rx_ready1 0;break} } ; return $td_rx_ready1 }
proc td_ctle_bw_adaptive_read  { chan avmm } { etile_pma_atribute  0x2C 0x0903 $chan $avmm ; return [etile_read_reg 0x88 $chan $avmm] }
proc td_gain_lf { chan avmm } { return [etile_pma_atribute 0x2c 0x0900 $chan $avmm] }
proc td_ctle_lf_min { chan avmm } { return [etile_pma_atribute 0x2c 0x909 $chan $avmm] }
proc td_ctle_lf_max { chan avmm } { return [etile_pma_atribute 0x2c 0x90A $chan $avmm] }
proc td_gain_hf { chan avmm } { return [etile_pma_atribute 0x2c 0x0901 $chan $avmm] }
proc td_ctle_hf_min { chan avmm } { return [etile_pma_atribute 0x2c 0x907 $chan $avmm] }
proc td_ctle_hf_max { chan avmm } { return [etile_pma_atribute 0x2c 0x908 $chan $avmm] }
proc td_gain_shape1 { chan avmm } { return [etile_pma_atribute 0x2c 0x904 $chan $avmm] }
proc td_gain_shape2 { chan avmm } { return [etile_pma_atribute 0x2c 0x905 $chan $avmm] }
proc td_rf_p2 { chan avmm } { return [etile_pma_atribute 0x2c 0x0d00 $chan $avmm] }
proc td_rf_p2_min { chan avmm } { return [etile_pma_atribute 0x2c 0x0d09 $chan $avmm] }
proc td_rf_p2_max { chan avmm } { return [etile_pma_atribute 0x2c 0x0d0a $chan $avmm] }
proc td_rf_p1 { chan avmm } { return [etile_pma_atribute 0x2c 0x0d01 $chan $avmm] }
proc td_rf_p1_min { chan avmm } { return [etile_pma_atribute 0x2c 0x0d07 $chan $avmm] }
proc td_rf_p1_max { chan avmm } { return [etile_pma_atribute 0x2c 0x0d08 $chan $avmm] }
proc td_rf_p0 { chan avmm } { return [etile_pma_atribute 0x2c 0x0d02 $chan $avmm] }
proc td_rf_b1 { chan avmm } { return [etile_pma_atribute 0x2c 0x0d04 $chan $avmm] }
proc td_rf_b0 { chan avmm } { return [etile_pma_atribute 0x2c 0x0d03 $chan $avmm] }
proc td_rf_b0t { chan avmm } { return [etile_pma_atribute 0x2c 0x200b $chan $avmm] }
proc find_ctle_lf_adaptive_manual  { chan avmm } {
	set value  [expr [etile_pma_atribute 0x2c 0x108 $chan $avmm] & 0x02]
    if {$value} { return "man" } else { return "adp" }
} 
proc find_ctle_hf_adaptive_manual  { chan avmm } {
	set value  [expr [etile_pma_atribute 0x2c 0x108 $chan $avmm] & 0x04]
    if {$value} { return "man" } else { return "adp" }
}
proc find_ctle_gs1_adaptive_manual  { chan avmm } {
	set value  [expr [etile_pma_atribute 0x2c 0x108 $chan $avmm] & 0x20]
    if {$value} { return "man" } else { return "adp" }
} 
proc find_ctle_gs2_adaptive_manual  { chan avmm } {
	set value  [expr [etile_pma_atribute 0x2c 0x108 $chan $avmm] & 0x10]
    if {$value} { return "man" } else { return "adp" }
} 
proc find_ctle_rf_b0_adaptive_manual  { chan avmm } {
	set value  [expr [etile_pma_atribute 0x2c 0x109 $chan $avmm] & 0x08]
    if {$value} { return "man" } else { return "adp" }
}
proc find_ctle_rf_b1_adaptive_manual  { chan avmm } {
	set value  [expr [etile_pma_atribute 0x2c 0x109 $chan $avmm] & 0x10]
    if {$value} { return "man" } else { return "adp" }
}

# ################################
# Procedures for Transceiver tab
# ################################
proc etile_read { phy } {
	global dash_xcvr_debug_tool_kit version
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]
	freeze_buttons_pma
	etile_read_update $phy	
	unfreeze_buttons_pma
}
proc etile_read_update { phy } {

	global dash_xcvr_debug_tool_kit version
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]
	set avmm [lindex [get_service_paths slave ] $phy]
	set no_of_channel [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.${phy}.no_of_chan]
	#set filename  [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.log_data_filename]	
	for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
	
		#set lock_to_data [td_read_cdrlocked_reg $chan $avmm]
		#set td_tx_ready_val [td_tx_ready $chan $avmm]
		#set td_rx_ready_val [td_rx_ready $chan $avmm]
		set td_vod_rd_val [ expr [td_vod_rd $chan $avmm] ]
		set post_tap1 [ expr [td_post_tap1 $chan $avmm] ]
		if { $post_tap1 > 127 } { set post_tap1 [ expr $post_tap1 - 256 ] } 
		set pre_tap1 [ expr [td_pre_tap1 $chan $avmm] ]
		if { $pre_tap1 > 127 } { set pre_tap1 [ expr $pre_tap1 - 256 ] }
		set pre_tap2 [ expr [td_pre_tap2 $chan $avmm] ]
		if { $pre_tap2 > 127 } { set pre_tap2 [ expr $pre_tap2 - 256 ] }
		set pre_tap3 [ expr [td_pre_tap3 $chan $avmm] ]
		if { $pre_tap3 > 127 } { set pre_tap3 [ expr $pre_tap3 - 256 ] }
		set gainshape1 [ expr [td_gain_shape1 $chan $avmm] ]
		set gainshape2 [ expr [td_gain_shape2 $chan $avmm] ]
		set rf_b1 [ expr [td_rf_b1 $chan $avmm] ]
		set rf_b0 [ expr [td_rf_b0 $chan $avmm] ]
		set gainhf [ expr [td_gain_hf $chan $avmm] ]
		set gainlf [ expr [td_gain_lf $chan $avmm] ]
		set rf_p2 [ expr [td_rf_p2 $chan $avmm] ]
		if { $rf_p2 > 127 } { set rf_p2 [ expr $rf_p2 - 256 ] }
		set rf_p1 [ expr [td_rf_p1 $chan $avmm] ]
		set rf_p0 [ expr [td_rf_p0 $chan $avmm] ]
		if { $rf_p0 > 127 } { set rf_p0 [ expr $rf_p0 - 256] }
		set rf_b0t [ expr [td_rf_b0t $chan $avmm] ]
		set ctle_lf_min [ expr [td_ctle_lf_min $chan $avmm] ]
		set ctle_lf_max [ expr [td_ctle_lf_max $chan $avmm] ]
		set ctle_hf_min [ expr [td_ctle_hf_min $chan $avmm] ]
		set ctle_hf_max [ expr [td_ctle_hf_max $chan $avmm] ]
		set rf_p2_min [ expr [td_rf_p2_min $chan $avmm] ]
		if { $rf_p2_min > 127 } { set rf_p2_min [ expr $rf_p2_min - 256 ] }
		set rf_p2_max [ expr [td_rf_p2_max $chan $avmm] ]
		if { $rf_p2_max > 127 } { set rf_p2_max [ expr $rf_p2_max - 256 ] }
		set rf_p1_min [ expr [td_rf_p1_min $chan $avmm] ]
		set rf_p1_max [ expr [td_rf_p1_max $chan $avmm] ]
		
		
		# if {$lock_to_data} {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_cdr_lock_to_data text "Locked"
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_cdr_lock_to_data foregroundColor green
				
		# } else {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_cdr_lock_to_data text "Unlocked"
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_cdr_lock_to_data foregroundColor red
		# }
			
		# if {$td_tx_ready_val} {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${phy}_${chan}_tx_ready text "High" 
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${phy}_${chan}_tx_ready foregroundColor green 
		# } else {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${phy}_${chan}_tx_ready text "Low" 
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${phy}_${chan}_tx_ready foregroundColor red
		# }
		
		# if {$td_rx_ready_val} {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${phy}_${chan}_rx_ready text "High" 
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${phy}_${chan}_rx_ready foregroundColor green 
			
		# } else {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${phy}_${chan}_rx_ready text "Low"
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${phy}_${chan}_rx_ready foregroundColor red
		# }
		
		
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_vod_attenuation text $td_vod_rd_val 
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_post_tap1 text $post_tap1 
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_pre_tap1 text $pre_tap1
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_pre_tap2 text $pre_tap2
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_pre_tap3 text $pre_tap3
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_gainshape1 text $gainshape1
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_gainshape2 text $gainshape2
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_b1 text $rf_b1
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_b0 text $rf_b0
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_gainlf text $gainlf
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_gainhf text $gainhf
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p2 text $rf_p2
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p1 text $rf_p1
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p0 text $rf_p0
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p2_min text $rf_p2_min
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p2_max text $rf_p2_max
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p1_min text $rf_p1_min
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p1_max text $rf_p1_max
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_b0t text $rf_b0t
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_ctle_lf_min text $ctle_lf_min
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_ctle_lf_max text $ctle_lf_max
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_ctle_hf_min text $ctle_hf_min
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_ctle_hf_max text $ctle_hf_max
		
		
		# write the log file the details of the iADP
				# #puts "PMA settings logged Read"
				# set data_log_file [open "$filename" "a+"]
				# puts -nonewline $data_log_file "[clock format [clock seconds] -format  %jjulian_%Hhr_%Mmin_%Ssec],"
				# puts -nonewline $data_log_file "$phy,"
				# puts -nonewline $data_log_file "$chan,"
				# #puts -nonewline $data_log_file "$lock_to_data," 
				# #puts -nonewline $data_log_file "$td_tx_ready_val,"
				# #puts -nonewline $data_log_file "$td_rx_ready_val,"
				# puts -nonewline $data_log_file "$td_vod_rd_val,"
				# puts -nonewline $data_log_file "$post_tap1,"
				# puts -nonewline $data_log_file "$pre_tap1,"
				# puts -nonewline $data_log_file "$pre_tap2,"
				# puts -nonewline $data_log_file "$pre_tap3,,"
				# puts -nonewline $data_log_file "$gainshape1,"
				# puts -nonewline $data_log_file "$gainshape2,"
				# puts -nonewline $data_log_file "$rf_b1,"
				# puts -nonewline $data_log_file "$rf_b0,"
				# puts -nonewline $data_log_file "$gainlf,"
				# puts -nonewline $data_log_file "$gainhf,"
				# puts -nonewline $data_log_file "$rf_p2,"
				# puts -nonewline $data_log_file "$rf_p1,"
				# puts -nonewline $data_log_file "$rf_p0,"
				# puts -nonewline $data_log_file "$rf_b0t,"
				# puts -nonewline $data_log_file "$ctle_lf_min,"
				# puts -nonewline $data_log_file "$ctle_lf_max,"
				# puts -nonewline $data_log_file "$ctle_hf_min,"
				# puts -nonewline $data_log_file "$ctle_hf_max,"
				# puts -nonewline $data_log_file "$rf_p2_min,"
				# puts -nonewline $data_log_file "$rf_p2_max,"
				# puts -nonewline $data_log_file "$rf_p1_min,"
				# puts -nonewline $data_log_file "$rf_p1_max,"				
				# puts $data_log_file "";	close $data_log_file
		
		
	}
	

}
	
proc read_all_phy {} {
	global dash_xcvr_debug_tool_kit version
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]		
	dashboard_set_property $dash1 etile_read_all_phy enabled false
		freeze_buttons_pma	
		foreach phy [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.phy_id] {
			kill_loop $phy $dash1
			etile_read_update $phy
		}
		unfreeze_buttons_pma
}
proc freeze_buttons_pma {} {
	
	
	global dash_xcvr_debug_tool_kit
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]	
	
	dashboard_set_property $dash1 etile_read enabled false
	
	# set no_of_channel [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.eli_no_of_channel]
		# for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
			# dashboard_set_property $dash1 etile_reset_$chan enabled false
		# }	

	
		
}
proc unfreeze_buttons_pma {} {

	#puts "Enter UNFreeze PMa"
	global dash_xcvr_debug_tool_kit
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]	
	
	dashboard_set_property $dash1 etile_read enabled true

	# set no_of_channel [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.eli_no_of_channel]
		# for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
			# dashboard_set_property $dash1 etile_reset_$chan enabled true
		# }	
		
	#puts "Enter Unfreeze PMa"	
}
proc set_pma_reset {chan} { 
	global dash_xcvr_debug_tool_kit version
	global jtag_master
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]		
	set avmm $jtag_master
	#dashboard_set_property $dash1 etile_reset_$chan enabled false
	if {1}  { puts "[lrange [info level [info level]] 0 0] Chan_[lrange [info level [info level]] 1 1]" }; 
	etile_rdmwrite 0x200 0xff 0x00 $chan $avmm
	etile_rdmwrite 0x201 0xff 0x00 $chan $avmm
	etile_rdmwrite 0x202 0xff 0x00 $chan $avmm
	etile_rdmwrite 0x203 0xff 0x81 $chan $avmm
	#Call the interrupt sequencer 
	etile_rdmwrite 0x91 0x01 0x01  $chan $avmm	
	eli_read_all_phy
	#dashboard_set_property $dash1 etile_reset_$chan enabled true
	
}
proc s10_write_reg {m base_addr offset bitmask newval} {

  #read from data register
  set value [master_read_8 $m [expr ($base_addr + $offset) * 4] 1]

  # bitwise-AND to clear out bitmask bits
  set value [expr $value & [expr 0xff & ~$bitmask]]
  set value [expr $value | [expr $newval & $bitmask]]

  master_write_8 $m [expr ($base_addr + $offset) * 4] $value

} 
 
	






proc eli_etile_read_update { chan avmm } {

	global dash_xcvr_debug_tool_kit version
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]
	#set filename  [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.log_data_filename]	
	
	
		#set lock_to_data [td_read_cdrlocked_reg $chan $avmm]
		#set td_tx_ready_val [td_tx_ready $chan $avmm]
		#set td_rx_ready_val [td_rx_ready $chan $avmm]
		set td_vod_rd_val [ expr [td_vod_rd $chan $avmm] ]
		set post_tap1 [ expr [td_post_tap1 $chan $avmm] ]
		if { $post_tap1 > 127 } { set post_tap1 [ expr $post_tap1 - 256 ] } 
		set pre_tap1 [ expr [td_pre_tap1 $chan $avmm] ]
		if { $pre_tap1 > 127 } { set pre_tap1 [ expr $pre_tap1 - 256 ] }
		set pre_tap2 [ expr [td_pre_tap2 $chan $avmm] ]
		if { $pre_tap2 > 127 } { set pre_tap2 [ expr $pre_tap2 - 256 ] }
		set pre_tap3 [ expr [td_pre_tap3 $chan $avmm] ]
		if { $pre_tap3 > 127 } { set pre_tap3 [ expr $pre_tap3 - 256 ] }
		set gainshape1 [ expr [td_gain_shape1 $chan $avmm] ]
		set gainshape2 [ expr [td_gain_shape2 $chan $avmm] ]
		set rf_b1 [ expr [td_rf_b1 $chan $avmm] ]
		set rf_b0 [ expr [td_rf_b0 $chan $avmm] ]
		set gainhf [ expr [td_gain_hf $chan $avmm] ]
		set gainlf [ expr [td_gain_lf $chan $avmm] ]
		set rf_p2 [ expr [td_rf_p2 $chan $avmm] ]
		if { $rf_p2 > 127 } { set rf_p2 [ expr $rf_p2 - 256 ] }
		set rf_p1 [ expr [td_rf_p1 $chan $avmm] ]
		set rf_p0 [ expr [td_rf_p0 $chan $avmm] ]
		if { $rf_p0 > 127 } { set rf_p0 [ expr $rf_p0 - 256] }
		set rf_b0t [ expr [td_rf_b0t $chan $avmm] ]
		set ctle_lf_min [ expr [td_ctle_lf_min $chan $avmm] ]
		set ctle_lf_max [ expr [td_ctle_lf_max $chan $avmm] ]
		set ctle_hf_min [ expr [td_ctle_hf_min $chan $avmm] ]
		set ctle_hf_max [ expr [td_ctle_hf_max $chan $avmm] ]
		set rf_p2_min [ expr [td_rf_p2_min $chan $avmm] ]
		if { $rf_p2_min > 127 } { set rf_p2_min [ expr $rf_p2_min - 256 ] }
		set rf_p2_max [ expr [td_rf_p2_max $chan $avmm] ]
		if { $rf_p2_max > 127 } { set rf_p2_max [ expr $rf_p2_max - 256 ] }
		set rf_p1_min [ expr [td_rf_p1_min $chan $avmm] ]
		set rf_p1_max [ expr [td_rf_p1_max $chan $avmm] ]
		
		
		# if {$lock_to_data} {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_cdr_lock_to_data text "Locked"
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_cdr_lock_to_data foregroundColor green
				
		# } else {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_cdr_lock_to_data text "Unlocked"
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_cdr_lock_to_data foregroundColor red
		# }
			
		# if {$td_tx_ready_val} {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_tx_ready text "High" 
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_tx_ready foregroundColor green 
		# } else {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_tx_ready text "Low" 
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_tx_ready foregroundColor red
		# }
		
		# if {$td_rx_ready_val} {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rx_ready text "High" 
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rx_ready foregroundColor green 
			
		# } else {
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rx_ready text "Low"
			# dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rx_ready foregroundColor red
		# }
		
		
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_vod_attenuation text $td_vod_rd_val 
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_post_tap1 text $post_tap1 
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_pre_tap1 text $pre_tap1
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_pre_tap2 text $pre_tap2
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_pre_tap3 text $pre_tap3
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_gainshape1 text $gainshape1
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_gainshape2 text $gainshape2
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_b1 text $rf_b1
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_b0 text $rf_b0
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_gainlf text $gainlf
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_gainhf text $gainhf
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p2 text $rf_p2
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p1 text $rf_p1
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p0 text $rf_p0
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p2_min text $rf_p2_min
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p2_max text $rf_p2_max
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p1_min text $rf_p1_min
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_p1_max text $rf_p1_max
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_rf_b0t text $rf_b0t
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_ctle_lf_min text $ctle_lf_min
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_ctle_lf_max text $ctle_lf_max
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_ctle_hf_min text $ctle_hf_min
		dashboard_set_property $dash1 etile_transceiver_debug_my_label_${chan}_ctle_hf_max text $ctle_hf_max
		
		
		# write the log file the details of the iADP
				#puts "PMA settings logged Read"
				# set data_log_file [open "$filename" "a+"]
				# puts -nonewline $data_log_file "[clock format [clock seconds] -format  %jjulian_%Hhr_%Mmin_%Ssec],"
				# puts -nonewline $data_log_file "$avmm,"
				# puts -nonewline $data_log_file "$chan,"
				# #puts -nonewline $data_log_file "$lock_to_data," 
				# #puts -nonewline $data_log_file "$td_tx_ready_val,"
				# #puts -nonewline $data_log_file "$td_rx_ready_val,"
				# puts -nonewline $data_log_file "$td_vod_rd_val,"
				# puts -nonewline $data_log_file "$post_tap1,"
				# puts -nonewline $data_log_file "$pre_tap1,"
				# puts -nonewline $data_log_file "$pre_tap2,"
				# puts -nonewline $data_log_file "$pre_tap3,,"
				# puts -nonewline $data_log_file "$gainshape1,"
				# puts -nonewline $data_log_file "$gainshape2,"
				# puts -nonewline $data_log_file "$rf_b1,"
				# puts -nonewline $data_log_file "$rf_b0,"
				# puts -nonewline $data_log_file "$gainlf,"
				# puts -nonewline $data_log_file "$gainhf,"
				# puts -nonewline $data_log_file "$rf_p2,"
				# puts -nonewline $data_log_file "$rf_p1,"
				# puts -nonewline $data_log_file "$rf_p0,"
				# puts -nonewline $data_log_file "$rf_b0t,"
				# puts -nonewline $data_log_file "$ctle_lf_min,"
				# puts -nonewline $data_log_file "$ctle_lf_max,"
				# puts -nonewline $data_log_file "$ctle_hf_min,"
				# puts -nonewline $data_log_file "$ctle_hf_max,"
				# puts -nonewline $data_log_file "$rf_p2_min,"
				# puts -nonewline $data_log_file "$rf_p2_max,"
				# puts -nonewline $data_log_file "$rf_p1_min,"
				# puts -nonewline $data_log_file "$rf_p1_max,"				
				# puts $data_log_file "";	close $data_log_file
		
		
	
	

}
	
proc eli_read_all_phy {} {
	global dash_xcvr_debug_tool_kit version
	global jtag_master
	#set avmm [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.jtag_master] 
	set avmm $jtag_master
	set no_of_channel [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.eli_no_of_channel]
	freeze_buttons_pma
	for { set chan 0 } { $chan < $no_of_channel } { incr chan } {
		eli_etile_read_update $chan $avmm 
	}
	unfreeze_buttons_pma
}

proc cont_eli_read_all_phy {} {
	
	#puts "Enter PMA Read"
	global dash_xcvr_debug_tool_kit version
	global jtag_master
	#set avmm [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.jtag_master] 
	
	set avmm $jtag_master
	set no_of_channel [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.eli_no_of_channel]
	
	for { set chan 0 } { $chan < $no_of_channel } { incr chan } {
	
		eli_etile_read_update $chan $avmm 
	}
	#puts "Exit PMA Read"
	
	
}

proc proc_pma_tab_continuous {} {

	global dash
	global pma_cont_enabled
	
	if { [dashboard_get_property $dash etile_pma_continuous_read checked] } {
		set pma_cont_enabled 1
		
	} else {
		set pma_cont_enabled 0
		
	}

}
	
# ################################
# Transceiver GUI start
# ################################

proc etile_CEI_transceiver_debug_init { } {
	
	global dash_xcvr_debug_tool_kit
	
	# finding all the native phy IP attached to the JTAG server and enumerating them
	set native_nos ""
	set k 0
	foreach temp [get_service_paths slave] {
		set condition1 [string match -nocase *native* [marker_get_info $temp]]
		set condition2 [string match -nocase *.slave* [marker_get_info $temp]]
		
		if { ($condition1 && $condition2 )} { 
			# puts "native found"
			lappend native_nos $k 
			# puts [lindex [marker_get_info "$temp"] 1]
			# set cable_info [string map {" " "_"} [lindex [split $temp "/"] 1]_[lindex [split $temp "/"] 2]]||
			set cable_info $temp
			dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.native.phy_id $k 
			dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.native.$k.cable_info $cable_info
		}
		incr k
	}
	
	
	foreach phy [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.phy_id] {
		# puts "kk1 $phy"
		dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.native.$phy.avmm [lindex [get_service_paths slave ] [lindex $native_nos $phy]]
		set avmm [lindex [get_service_paths slave ] $phy]
		dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.native.$phy.no_of_chan [expr [ etile_read_reg 0x40010 0 "$avmm"]]
		# dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.native.$phy.no_of_chan 1
	}
	
	
	
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title "Status" "Transmitter" "Receiver_Adaptation" "RX_Analog_Settings" 
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Status "cdr_lock_to_data" "tx_ready" "rx_ready"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Transmitter "vod_attenuation" "post_tap1" "pre_tap1" "pre_tap2" "pre_tap3"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Receiver_Adaptation "gainshape1" "gainshape2" "rf_b1" "rf_b0" "gainlf" "gainhf" "rf_p2" "rf_p1" "rf_p0" 		
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.RX_Analog_Settings "rf_p2_min" "rf_p2_max" "rf_p1_min" "rf_p1_max" "rf_b0t" "ctle_lf_min" "ctle_lf_max" "ctle_hf_min" "ctle_hf_max" 
	
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Valid_range_Param "Transmitter" "Receiver_Adaptation" "RX_Analog_Settings"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Transmitter.Valid_range "0_to_31" "-31_to_+31" "-31_to_+31" "-31_to_+31" "-1_to+1"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Receiver_Adaptation.Valid_range "0_to_3" "0_to_3" "0_to_8" "0_to_5" "0_to_15" "0_to_15" "-10_to_+10" "0_to_15" "-15_to_+15"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.RX_Analog_Settings.Valid_range "-10_to_+10" "-10_to_+10" "0_to_15" "0_to_15" "0_to_15" "0_to_15" "0_to_15" "0_to_15" "0_to_15"    
	
	if { ![file isdirectory log] } {file mkdir log} 
	set filename "log/etile_transceiver_debug_[clock format [clock seconds] -format  %jjulian_%Hhr_%Mmin_%Ssec]_[info hostname].csv"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.log_data_filename $filename
	set data_log_file [open "$filename" "w"]
	puts -nonewline $data_log_file "TIME,"
	puts -nonewline $data_log_file "PHY,"
	puts -nonewline $data_log_file "CHAN,"
	puts -nonewline $data_log_file "CDRLOCK,"
	puts -nonewline $data_log_file "TX_ready,"
	puts -nonewline $data_log_file "RX_ready,"
	puts -nonewline $data_log_file "Vod_Attenuation,"
	puts -nonewline $data_log_file "Post_tap1,"
	puts -nonewline $data_log_file "Pre_tap1,"
	puts -nonewline $data_log_file "Pre_tap2,"
	puts -nonewline $data_log_file "Pre_tap3,"
	puts -nonewline $data_log_file "Gainshape1,"
	puts -nonewline $data_log_file "Gainshape2,"
	puts -nonewline $data_log_file "rf_b1,"
	puts -nonewline $data_log_file "rf_b0,"
	puts -nonewline $data_log_file "Gainlf,"
	puts -nonewline $data_log_file "Gainhf,"
	puts -nonewline $data_log_file "rf_p2,"
	puts -nonewline $data_log_file "rf_p1,"
	puts -nonewline $data_log_file "rf_p0,"
	puts -nonewline $data_log_file "rf_b0t,"
	puts -nonewline $data_log_file "ctle_lf_min,"
	puts -nonewline $data_log_file "ctle_lf_max,"
	puts -nonewline $data_log_file "ctle_hf_min,"
	puts -nonewline $data_log_file "ctle_hf_max,"
	puts -nonewline $data_log_file "rf_p2_min,"
	puts -nonewline $data_log_file "rf_p2_max,"
	puts -nonewline $data_log_file "rf_p1_min,"
	puts -nonewline $data_log_file "rf_p1_max,"
	puts $data_log_file "";	close $data_log_file
	
}
proc etile_CEI_spec_transceiver_debug_gui_tab { } {
		global dash_xcvr_debug_tool_kit version
		set dash1 [add_service dashboard S10_Etile_transceiver_debug_[clock format [clock seconds] -format  %Hhr_%Mmin_%Ssec]_v${version} "S10_Etile_transceiver_debug_v${version}" "Tools/S10_Etile_transceiver_debug_v${version}"]
		dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash $dash1
		
		td_widget_group $dash1 etile_transceiver_debug_top self 1 ""
		
			td_widget_group $dash1 Transceiver_status_comment etile_transceiver_debug_top 1 "Comments"
			
				td_widget_label $dash1 my_label1 Transceiver_status_comment   "** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **" green
				td_widget_label $dash1 my_label1 Transceiver_status_comment   "1.To use this tool ADME should be Enabled for accesing PMA registers " blue
				td_widget_label $dash1 my_label1 Transceiver_status_comment   "2.Capability register should be enabled for reading CDRLOCK register" blue
				td_widget_label $dash1 my_label1 Transceiver_status_comment   "3.For PAM4 design, consider only even channels. This is fixed from Quartus 18.1 onwards." blue
				td_widget_label $dash1 my_label1 Transceiver_status_comment   " " blue
				td_widget_label $dash1 my_label1 Transceiver_status_comment   "** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** **" green
			
			td_widget_group $dash1 init_Table etile_transceiver_debug_top 1 "Profile Lookup Table"
				etile_CEI_spec_init_gui_tab $dash1 "init_Table"
			
			td_widget_group $dash1 phy_Table etile_transceiver_debug_top 3 "PHY Table"
				set phy_id 1
				foreach phy [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.phy_id] {
				
					set avmm [lindex [get_service_paths slave ] $phy]
					td_widget_label $dash1 phy_label phy_Table $phy_id
					td_widget_label $dash1 phy_label phy_Table $avmm
					td_widget_button $dash1 etile_readphy_$phy phy_Table "Read" "etile_read $phy"
					incr phy_id
				}	
			
				
				
			#if {[llength [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.phy_id]] > 1 } {
			td_widget_group $dash1 etile_all_phy etile_transceiver_debug_top 2 ""
				td_widget_button $dash1 etile_read_all_phy etile_all_phy "Read All PHY" "read_all_phy"
				td_widget_checkBox $dash1 kill_loop_all etile_all_phy "kill" "kill_loop all $dash1" false red
			#}
				
				
			td_widget_group $dash1 etile_transceiver_debug_ch etile_transceiver_debug_top 1 "PHY + Channel"
					
			dashboard_add $dash1 phy_status tabbedGroup etile_transceiver_debug_ch		
			
				set phy_number 0
				
				foreach phy [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.phy_id] {
					
					set avmm [lindex [get_service_paths slave ] $phy]
					set cable_name [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.$phy.cable_info]
					set transceiver_debug_phy_name [lindex [marker_get_info [lindex [get_service_paths slave] $phy]] 3]
					set avmm_split [split $avmm /]
					set avmm_cable_name ""
					
					set temp_var 1
					foreach avmm_split_ele $avmm_split {
						append avmm_cable_name "/" $avmm_split_ele	
						incr temp_var
						if {$temp_var == 4} {
							break
						}	
					}	
								
					set no_of_channel [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.${phy}.no_of_chan]
					set total_column [expr 1 + $no_of_channel]
					
					
					td_widget_group $dash1 ${transceiver_debug_phy_name}_top phy_status 1 "PHY ${phy_number}" 
						
						if {[llength [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.native.phy_id]] > 1 } {	
						td_widget_group $dash1 etile_read_group ${transceiver_debug_phy_name}_top 1 ""
 						td_widget_button $dash1 etile_read_$phy etile_read_group "Read" "etile_read $phy"
						#td_widget_checkBox $dash1 kill_loop_$phy  $transceiver_debug_phy_name "kill" "kill_loop $phy $dash1" false red
						}									
						td_widget_group $dash1 $transceiver_debug_phy_name ${transceiver_debug_phy_name}_top $total_column "Cable name = ${avmm_cable_name}  ***** JTAG = ${transceiver_debug_phy_name}"
												
						# ############################################################################################################## 
						#### Global values
						row 1
						td_widget_label $dash1 etile_transceiver_debug_my_label_1  $transceiver_debug_phy_name   "--------------------" black
						for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
							td_widget_label 		$dash1 etile_transceiver_debug_my_label_1_ch_$chan   $transceiver_debug_phy_name   "  channel_${chan}  " black
						
						}
						#Row 2
						td_widget_label $dash1 etile_transceiver_debug_my_label_1  $transceiver_debug_phy_name   "--------------------" black
						for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
							td_widget_buttonwidth 		$dash1 etile_reset_${phy}_$chan   $transceiver_debug_phy_name   "Reset" "set_pma_reset $chan $avmm $phy" 25
						
						}
						
						foreach ch_pa_title [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title] {
							
							td_widget_group $dash1 $ch_pa_title ${transceiver_debug_phy_name}_top $total_column "${ch_pa_title}" 
							td_widget_label $dash1 etile_transceiver_debug_my_label_1  $ch_pa_title    "--------------------" black
							for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
								# td_widget_labelwidth $dash1 1 etile_transceiver_debug_my_label_1_ch_$chan   $ch_pa_title   "Channel_${chan}" 250
								td_widget_label $dash1 etile_transceiver_debug_my_label_1_ch_$chan   $ch_pa_title   "  channel_${chan}  " black 
							}
							
							foreach ch_pa [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.$ch_pa_title] {
								# set ch_pa1 [format "%-*s" [ expr [string length $ch_pa] + ([string length "cdr_lock_to_data"] - [string length $ch_pa])] $ch_pa]
								# td_widget_labelwidth $dash1 1 etile_transceiver_debug_my_label_$phy  $ch_pa_title   "$ch_pa" 250	
								td_widget_label $dash1 etile_transceiver_debug_my_label_$phy  $ch_pa_title   "$ch_pa" black
								# td_widget_label $dash1 1 etile_transceiver_debug_my_label_$phy  $ch_pa_title   "$ch_pa"	
								for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {						
									# td_widget_labelwidth $dash1 1 etile_transceiver_debug_my_label_${phy}_${chan}_${ch_pa} $ch_pa_title  "" 250
									td_widget_textBox $dash1 1 etile_transceiver_debug_my_label_${phy}_${chan}_${ch_pa} $ch_pa_title 0 "--" 7 30 
								}					
							}
						}
						
					
					
					
					
				incr phy_number	
				}	
}

proc etile_ELI_transceiver_debug_init {  eli_dash_tab eli_no_of_channel dash } {
	
	global dash_xcvr_debug_tool_kit
	global jtag_master
	global jtag_master_handle
	set dash_xcvr_debug_tool_kit {}	
	
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash $dash
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.eli_dash_tab $eli_dash_tab
	#dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.jtag_master $jtag_master
	#dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.jtag_master_handle $jtag_master_handle
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.eli_no_of_channel $eli_no_of_channel
	
	
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title "Transmitter" "Receiver_Adaptation" "RX_Analog_Settings" 
	#dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Status "cdr_lock_to_data" "tx_ready" "rx_ready"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Transmitter "vod_attenuation" "post_tap1" "pre_tap1" "pre_tap2" "pre_tap3"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Receiver_Adaptation "gainshape1" "gainshape2" "rf_b0" "rf_b1" "gainlf" "gainhf" "rf_p2" "rf_p1" "rf_p0" 		
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.RX_Analog_Settings "rf_p2_min" "rf_p2_max" "rf_p1_min" "rf_p1_max" "rf_b0t" "ctle_lf_min" "ctle_lf_max" "ctle_hf_min" "ctle_hf_max" 
	
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Valid_range_Param "Transmitter" "Receiver_Adaptation" "RX_Analog_Settings"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Transmitter.Valid_range "0 to 31" "-31 to +31" "-31 to +31" "-31 to +31" "-1 to +1"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Receiver_Adaptation.Valid_range "0 to 3" "0 to 3" "0 to 8" "0 to 5" "0 to 15" "0 to 15" "-10 to +10" "0 to 15" "-15 to +15"
	dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.RX_Analog_Settings.Valid_range "-10 to +10" "-10 to +10" "0 to 15" "0 to 15" "0 to 15" "0 to 15" "0 to 15" "0 to 15" "0 to 15"    
	
	# if { ![file isdirectory log] } {file mkdir log} 
	# set filename "log/etile_transceiver_debug_[clock format [clock seconds] -format  %jjulian_%Hhr_%Mmin_%Ssec]_[info hostname].csv"
	# dict lappend dash_xcvr_debug_tool_kit etile_transceiver_debug.log_data_filename $filename
	# set data_log_file [open "$filename" "w"]
	# puts -nonewline $data_log_file "TIME,"
	# puts -nonewline $data_log_file "PHY,"
	# puts -nonewline $data_log_file "CHAN,"
	# #puts -nonewline $data_log_file "CDRLOCK,"
	# #puts -nonewline $data_log_file "TX_ready,"
	# #puts -nonewline $data_log_file "RX_ready,"
	# puts -nonewline $data_log_file "Vod_Attenuation,"
	# puts -nonewline $data_log_file "Post_tap1,"
	# puts -nonewline $data_log_file "Pre_tap1,"
	# puts -nonewline $data_log_file "Pre_tap2,"
	# puts -nonewline $data_log_file "Pre_tap3,"
	# puts -nonewline $data_log_file "Gainshape1,"
	# puts -nonewline $data_log_file "Gainshape2,"
	# puts -nonewline $data_log_file "rf_b1,"
	# puts -nonewline $data_log_file "rf_b0,"
	# puts -nonewline $data_log_file "Gainlf,"
	# puts -nonewline $data_log_file "Gainhf,"
	# puts -nonewline $data_log_file "rf_p2,"
	# puts -nonewline $data_log_file "rf_p1,"
	# puts -nonewline $data_log_file "rf_p0,"
	# puts -nonewline $data_log_file "rf_b0t,"
	# puts -nonewline $data_log_file "ctle_lf_min,"
	# puts -nonewline $data_log_file "ctle_lf_max,"
	# puts -nonewline $data_log_file "ctle_hf_min,"
	# puts -nonewline $data_log_file "ctle_hf_max,"
	# puts -nonewline $data_log_file "rf_p2_min,"
	# puts -nonewline $data_log_file "rf_p2_max,"
	# puts -nonewline $data_log_file "rf_p1_min,"
	# puts -nonewline $data_log_file "rf_p1_max,"
	# puts $data_log_file "";	close $data_log_file
	
}
proc etile_ELI_transceiver_debug_gui_tab {} {

		global dash_xcvr_debug_tool_kit
		global jtag_master
		set top_dash_tab_name [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.eli_dash_tab ]
		set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash ]
		
		td_widget_group $dash1 etile_pma_status_kr $top_dash_tab_name 1 "PMA"
		
						
			#set avmm $jtag_master
			#set transceiver_debug_phy_name $jtag_master
			set no_of_channel [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.eli_no_of_channel]
			set total_column [expr 1 + $no_of_channel]
			
		td_widget_group  $dash1 etile_pma_status_top_group etile_pma_status_kr 2 ""
		
			td_widget_group  $dash1 etile_pma_status_top etile_pma_status_top_group 1 ""
			
			td_widget_group  $dash1 etile_read_group etile_pma_status_top 1 ""
				
				
				td_widget_button $dash1 etile_read etile_read_group "Read" "eli_read_all_phy"
			
			# td_widget_group $dash1 Reset_Channel etile_pma_status_top $total_column "Reset Channel(s)"
				# # ############################################################################################################## 
				# td_widget_label $dash1 etile_transceiver_debug_my_label_1  Reset_Channel   "--------------------" black
				# for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
					# td_widget_label 		$dash1 etile_transceiver_debug_my_label_1_ch_$chan   Reset_Channel   "  channel_${chan}  " black
				# }
				
				# td_widget_label $dash1 etile_transceiver_debug_my_label_1  Reset_Channel   "--------------------" black
				# for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
					# td_widget_buttonwidth 		$dash1 etile_reset_$chan   Reset_Channel   "Reset" "set_pma_reset $chan" 25
				# }
			#########			
			td_widget_group $dash1 etile_pma_status etile_pma_status_top $total_column "PMA Parameter"
				
				td_widget_checkBox $dash1 etile_pma_continuous_read etile_pma_status "Include this section in continuous read" proc_pma_tab_continuous "false" black 
				for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
						td_widget_label $dash1 etile_transceiver_debug_my_label_x_ch_$chan   etile_pma_status   "" black 
					}
					
				foreach ch_pa_title [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title] {
					if {$ch_pa_title == "Transmitter"} {
					td_widget_label $dash1 etile_transceiver_debug_my_label_0 etile_pma_status "" 
					for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
						td_widget_label $dash1 etile_transceiver_debug_my_label_1_ch_$chan   etile_pma_status   "  channel_${chan}  " black 
					}
					}
					td_widget_label $dash1 etile_transceiver_debug_my_label_1 etile_pma_status "${ch_pa_title}" blue
					for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {
						td_widget_label $dash1 etile_transceiver_debug_my_label_2_ch_$chan   etile_pma_status   "" black 
					}
					foreach ch_pa [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.$ch_pa_title] {
						td_widget_label $dash1 etile_transceiver_debug_my_label  etile_pma_status   "$ch_pa" black
						for {set chan 0 } { $chan < $no_of_channel  } {incr chan } {						
							td_widget_textBox $dash1 1 etile_transceiver_debug_my_label_${chan}_${ch_pa} etile_pma_status 0 "--" 7 100 
						}					
					}
			}
			
			
			widget_groupHeight 1 pma_status_dummygroup etile_pma_status_top 1 "" 650
			proc_pma_tab_continuous
			
			
			
}

proc etile_CEI_spec_init_gui_tab { dash1 group } {
	global dash_xcvr_debug_tool_kit version
	
	set columnCount 24
	set rowCount 1
					
	set name "table1"			
	dashboard_add $dash1 $name table $group
	dashboard_set_property $dash1 $name preferredWidth 2000
	dashboard_set_property $dash1 $name preferredHeight [expr $rowCount*45]
	dashboard_set_property $dash1 $name columnCount $columnCount
	dashboard_set_property $dash1 $name rowCount $rowCount
	dashboard_set_property $dash1 $name headerReorderingAllowed "true"
	dashboard_set_property $dash1 $name headerResizingAllowed "true"
	dashboard_set_property $dash1 $name showGrid "true"
	dashboard_set_property $dash1 $name expandableX true

	
	#populating the header row
	dashboard_set_property $dash1 $name rowIndex 0
	dashboard_set_property $dash1 $name columnIndex 0
	dashboard_set_property $dash1 $name columnHeader " " 
	set curr_column 1
	foreach ch_pa_title [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Valid_range_Param] {
		foreach ch_pa [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.$ch_pa_title] {
			
		dashboard_set_property $dash1 $name columnIndex $curr_column
		dashboard_set_property $dash1 $name columnHeader $ch_pa 
		incr curr_column
		}
	}
	
	
	set curr_column 0
	dashboard_set_property $dash1 $name rowIndex 0
	dashboard_set_property $dash1 $name columnIndex $curr_column
	dashboard_set_property $dash1 $name cellText "Valid_range"
	dashboard_set_property $dash1 $name cellBackgroundColor blue
	dashboard_set_property $dash1 $name cellForegroundColor yellow
	
	set curr_column 1
	foreach ch_pa_title [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.Valid_range_Param] {
		foreach ch_pa_range [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.ch_param_title.${ch_pa_title}.Valid_range] {
			
		dashboard_set_property $dash1 $name columnIndex $curr_column
		dashboard_set_property $dash1 $name cellText $ch_pa_range 
		incr curr_column
		}
	}
	 
}			
	   

# ########################################################################################################################
# td_widget function
# ########################################################################################################################
proc td_widget_group 		{dash name group itemsPerRow text {preferredWidth 0}} {
	if {0} { puts [info level 0] }	
	dashboard_add $dash $name group $group
	dashboard_set_property $dash $name itemsPerRow $itemsPerRow
	dashboard_set_property $dash $name title $text
	# puts "td_widget_group $preferredWidth"
	if $preferredWidth {dashboard_set_property $dash $name preferredWidth $preferredWidth }
}
proc td_widget_checkBox 	{dash name group text onClick {value "false"} {foregroundColor red} {enabled_val "true"} } {
	dashboard_add $dash $name checkBox $group
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name onClick $onClick
	dashboard_set_property $dash $name checked $value
	dashboard_set_property $dash $name foregroundColor	$foregroundColor
	dashboard_set_property $dash $name enabled	$enabled_val
	
}
proc td_widget_button 		{dash name group text onClick } {
	dashboard_add $dash $name button $group
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name onClick $onClick
	
}
proc td_widget_buttonwidth 		{dash name group text onClick width } {
	dashboard_add $dash $name button $group
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name onClick $onClick
	dashboard_set_property $dash $name preferredWidth $width
	
}
proc td_widget_label 		{dash name group text {foregroundColor black} } {

	dashboard_add $dash $name label $group
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name foregroundColor	$foregroundColor
}
proc td_widget_labelwidth {dash1 add name group text width} {
	
	if {$add} {
		dashboard_add $dash1 $name label $group
	}
	dashboard_set_property $dash1 $name text $text
	#dashboard_set_property $dash $name foregroundColor $foregroundColor
	dashboard_set_property $dash1 $name preferredWidth $width
}
proc td_widget_comboBox 	{dash name group options selectedItem {foregroundColor black} {label ""} {enabled_Val "true"} {onClick "" } } {

	dashboard_add $dash $name comboBox $group
	dashboard_set_property $dash $name options $options
	dashboard_set_property $dash $name selectedItem $selectedItem
	dashboard_set_property $dash $name foregroundColor $foregroundColor
	dashboard_set_property $dash $name label $label
	dashboard_set_property $dash $name enabled $enabled_Val
	dashboard_set_property $dash $name onChange $onClick
}
proc td_widget_table 	{dash name group columnCount rowCount headerReorderingAllowed headerResizingAllowed showGrid showHorizontalLines showVertiADPLines  } {
	dashboard_add $dash $name checkBox $group
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name onClick $onClick
	dashboard_set_property $dash $name checked $value
	dashboard_set_property $dash $name foregroundColor	$foregroundColor
	dashboard_set_property $dash $name enabled	$enabled_val
	
}
proc td_widget_textBox {dash add name group editable text preferredHeight preferredWidth} {
	if {$add} {
		dashboard_add $dash $name text $group
	}
	dashboard_set_property $dash $name editable $editable
	dashboard_set_property $dash $name text $text
	dashboard_set_property $dash $name preferredHeight $preferredHeight
    dashboard_set_property $dash $name preferredWidth $preferredWidth
}

proc rforeach { varlist vallist args } {
   
     set i 0
	 
     foreach v $varlist {
         set localName x$[incr i]
         lappend localNames $localName
         upvar 1 $v $localName
     }
     foreach $localNames $vallist {
         if { [llength $args] <= 1 } {
             set status [catch {
                 uplevel 1 [lindex $args 0]
             } result]
         } else {
			
             set status [catch {
                 uplevel 1 [linsert $args 0 rforeach_nested]
             } result]
         }
         if { $status != 0 && $status != 4 } break
     }
     switch -exact -- $status {
         0 - 3 - 4 {
             return
         }
         1 {
             return -code error -errorcode $::errorCode $result
         }
         2 {
             return -code return $result
         }
     }
 }
 
proc rforeach_nested { varlist vallist args } {
 
     set i 0
     foreach v $varlist {
         set localName x$[incr i]
         lappend localNames $localName
         upvar 1 $v $localName
     }
     foreach $localNames $vallist {
         if { [llength $args] <= 1 } {
             set status [catch {
                 uplevel 1 [lindex $args 0]
             } result]
         } else {
             set status [catch {
                 uplevel 1 [linsert $args 0 rforeach_nested]
             } result]
         }
         if { $status != 0 && $status != 4 } break
     }
     switch -exact -- $status {
         0 - 4 {
             return
         }
         1 {
             return -code error -errorcode $::errorCode $result
         }
         2 {
             return -code return $result
         }
         3 {
             return -code break
         }
     }
 }
proc kill_loop 			{phy dash1 } {
if {0} { puts [info level 0] }
	global dash_xcvr_debug_tool_kit 
		#set data_log_file_close 0
		# puts [dashboard_get_property $dash1 kill_loop_$phy checked]
		set kill_all 0 
		set kill_all [string match [dashboard_get_property $dash1 kill_loop_all checked] "true"] 
		
		#set kill_all_phy [string match [dashboard_get_property $dash1 kill_loop_$phy checked] "true"] 
		
		if {$kill_all } {
			
			#ODI
			set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]
			unfreeze_buttons_pma			
			puts "**** Request made to stop the measurement ****"
			puts "**** Request made to stop the measurement ****"
			puts "**** Request made to stop the measurement ****"
			error "**** Request made to stop the measurement ****"
			error "**** Request made to stop the measurement ****"
			error "**** Request made to stop the measurement ****"
		}
	
}


# ###########################################################################
# ###########################################################################


if 0 {
	#set sof_path {C:\Users\sgirisan\system_console\scripts\nrz_1ch.sof}
	set sof_path {C:\Users\sgirisan\system_console\scripts\devkit_demo.sof}
	# set sof_path {C:\Users\kbalakri\system_console\scripts\nrz_2ch_soft_genver.sof}
	# set sof_path {C:\Users\kbalakri\system_console\scripts\56g_pam4.sof}
	puts "Loading ${sof_path} Design" ; set design [design_load $sof_path] ; puts "Loading Done"
	puts "refresh connections"; refresh_connections
	after 1000
	puts "loading Done"

}
if 0 {
	set version "Q18p0p1_v1p0"
	set status_tool_type_for_reg_read_write "native_phy_adme_enabled"
	set dash_xcvr_debug_kit {}
	set dash_xcvr_debug_tool_kit {}	
	set XCVR_DEBUG_TOOL_KIT_BASE_ADDRESS 0x80000
	puts "\n** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** "
	puts "S10_Etile_tuning_v${version} Load Start 	- Current time- [clock format [clock seconds] -format  %Hhr_%Mmin_%Ssec]"
	etile_CEI_transceiver_debug_init
	etile_CEI_spec_transceiver_debug_gui_tab
	puts "** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** "
	set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]
	dashboard_set_property $dash1 self visible true
	puts "S10_Etile_tuning_v${version} Load Stop 	- Current time- [clock format [clock seconds] -format  %Hhr_%Mmin_%Ssec]"
	puts "** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** "
	puts "Tools Loaded"

	set avmm [lindex [get_service_paths slave] 1]
	set chan 0
	
}

if 1 {
	global  master_claim_path 
	global 	selected_jtag 
	global 	jtag_master_list
	global 	BASE_ETILE_EHIPC3_100G_XCVR_LO
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L1
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L2
	global 	BASE_ETILE_EHIPC3_100G_XCVR_L3
	global 	ip_sub_variant_option 
	global status_tool_type_for_reg_read_write
	global XCVR_DEBUG_TOOL_KIT_BASE_ADDRESS
	
	set eli_dash_tab allstatus_etile_ehipc3_100g
	#set jtag_master [lindex $jtag_master_list $selected_jtag]
	#set jtag_master_handle $master_claim_path
	set eli_base_address $BASE_ETILE_EHIPC3_100G_XCVR_LO 
	set status_tool_type_for_reg_read_write "ELI"
	
	set dash_xcvr_debug_kit {}
	set dash_xcvr_debug_tool_kit {}	
	set XCVR_DEBUG_TOOL_KIT_BASE_ADDRESS $eli_base_address
	
	########
	if {$ip_sub_variant_option == "100g_nrz"} {
	set eli_no_of_channel 4
	} elseif {$ip_sub_variant_option == "100g_pam4"} {
	set eli_no_of_channel 2
	} elseif {$ip_sub_variant_option == "25g_nrz"} {
	set eli_no_of_channel 1
	} elseif {$ip_sub_variant_option == "10g_nrz"} {
	set eli_no_of_channel 1
	}
	######
		
	#puts "\n** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** "
	#puts "S10_Etile_tuning_ Load Start 	- Current time- [clock format [clock seconds] -format  %Hhr_%Mmin_%Ssec]"
	etile_ELI_transceiver_debug_init $eli_dash_tab $eli_no_of_channel $dash
	etile_ELI_transceiver_debug_gui_tab 
	#puts "** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** "
	#set dash1 [dict get $dash_xcvr_debug_tool_kit etile_transceiver_debug.GUI_dash]
	#dashboard_set_property $dash1 self visible true
	#puts "S10_Etile_tuning_ Load Stop 	- Current time- [clock format [clock seconds] -format  %Hhr_%Mmin_%Ssec]"
	#puts "** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** ** "
	#puts "Tools Loaded"

	#set avmm [lindex [get_service_paths slave] 1]
	#set chan 0
	
}
